;;----------------------;;
;; skeleton-edit.l       ;;
;;   for skeleton editor ;;
;;----------------------;;

;; ------ ;;
;; reload ;;
;; ------ ;;

(defun init_window () 'dummy-function)

(defun current-directory ()
  (let ((tmpfile (string-append "/tmp/ya" (date-time))))
    (call (string-append "echo \""`pwd`\"" > " tmpfile))
    (lets ((s (inopen (stream tmpfile)))
	   (ret (read s)))
      (close s)
      (call (string-append "rm " tmpfile))
      ret)))

(defun reload-skeleton ((load-primitive-all t))
  (reload-skeleton load-primitive-all))

(defun reload-skeleton ((load-primitive-all t))
  (let ((curdir (current-directory))
	(source-of-binary-files '(			  
				  "./tools/addhira.l"
				  "./tools/addprim.l"
				  "./tools/affinprim.l"
				  "./tools/aplyknj.l"
				  "./tools/delprim.l"
				  "./tools/dist.l"
				  "./tools/delhirapnt.l"
				  "./tools/drag-line.l"
				  "./tools/draw.l"
				  "./tools/edhira.l"
				  "./tools/edjoint.l"
				  "./tools/edprim.l"
				  "./tools/etc.l"
				  "./tools/han2zen.l"
				  "./tools/hirapoint.l"
				  "./tools/init.l"
				  "./tools/loop.l"
				  "./tools/message.l"
				  "./tools/movebox.l"
				  "./tools/nolink.l"
				  "./tools/primdef.l"
				  "./tools/primdisp.l"
				  "./tools/resizebox.l"
				  "./tools/skel-lib.l"
				  "./tools/slider.l"
				  "./tools/whichprim.l"
				  "./tools/xyunit.l")))
    
    (cd "/home/misa/kanji/lib")
    
    (cond ((definedp 'connect-to-server)
	   nil)
	  (t
	   (exfile "/usr/local/lib/utilisp/ulx/loadulx.l")))
    
    (cond ((and (boundp 'source-load) (not (null source-load)))
	   (mapcar source-of-binary-files #'load))
	  (t
	   (let ((binary-files
		  (mapcar source-of-binary-files 
			  #'(lambda (name)
			      (string-append
			       (substring name 0 (1- (string-length name)))
			       "o")))))
	     (code-load binary-files))))

    (load "./tools/skeledit.l")
    (load "./tools/kinput.l")
    (load "./tools/nocompile.l")
    (load "./tools/ulxbug.l")
    (load "./tools/primref.l")
    (load "./tools/askyn.l")
    
    (when load-primitive-all
      (comment setq makekanjilist t)
      (load "./load.l")
;      (load "./gothic.l")
;      (load "./startup-hira.l")
;      (load "./prim-patch.l")
      )

    (cd curdir)
    nil))

(defun skeleton-edit-and-save (editee editee-name filename)
  (print editee-name terminal-output)
  (let* ((result (skeleton-edit editee))
	 (standard-output (appendopen (stream filename))))
    (prind `(setq ,editee-name ',result))
    (terpri)
    (close standard-output)))

(defun reload-ulx-tools ()
  (reload-skeleton t))
    
(reload-ulx-tools)
